=== debian/changelog ===
ros-foxy-octomap (1.9.8-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Armin Hornung <armin@hornung.io>  Fri, 13 May 2022 15:55:09 -0000
